---
title: MDN conventions and definitions
slug: MDN/Guidelines/Conventions_definitions
tags:
  - Documentation
  - Guide
  - Guidelines
  - MDN
  - MDN Meta
---
<div>{{MDNSidebar}}</div>

<p class="summary">This article defines some conventions and definitions that are commonly used on MDN, which might not be obvious to some people when they come across them in the documentation.</p>

<h2 id="Definitions">Definitions</h2>

<h3 id="Deprecated_and_obsolete">Deprecated and obsolete</h3>

<p><strong>D</strong><strong>eprecated</strong> and <strong>obsolete</strong> are common terms associated with technologies and specifications, but what do they mean?</p>

<dl>
 <dt>Deprecated</dt>
 <dd>On MDN, the term <strong>deprecated</strong> used to mark an API or technology that is no longer recommended, but is still implemented and may still work. More recently, we've updated it to the definition used in our <a href="https://github.com/mdn/browser-compat-data/blob/master/schemas/compat-data-schema.md#status-information">browser-compat-data project</a>, which is that "the feature is no longer recommended. It might be removed in the future or might only be kept for compatibility purposes. Avoid using this functionality."</dd>
 <dt>Obsolete</dt>
 <dd>On MDN, the term <strong>obsolete</strong> used to mark an API or technology that is not only no longer recommended, but also no longer implemented in browsers. This was however confusing — it is similar to deprecated, and the distinction is not very helpful (you still shouldn't use it in a production site). We are therefore not using it anymore, and any instances you come across should be removed/replaced by deprecated.</dd>
</dl>

<h3 id="Experimental">Experimental</h3>

<p><strong>Experimental</strong> can mean different things depending on the context you hear or read it in. When a technology is described as experimental on MDN, it means that the technology is nascent and immature, and currently in the process of being added to the Web platform (or considered for addition).</p>

<p>One or both of these will be true:</p>

<ul>
 <li>It is implemented and enabled by default in less than two modern major browsers.</li>
 <li>Its defining spec is likely to change significantly, in backwards-incompatible ways (i.e. it may break existing code that relies on the feature).</li>
</ul>

<p>If one or both of these definitions is true, then you should think carefully before you start using that technology in any kind of production project (i.e. not just a demo or experiment). See also the definition of experimental in our <a href="https://github.com/mdn/browser-compat-data/blob/master/schemas/compat-data-schema.md#status-information">browser-compat-data project</a>.</p>

<p>Conversely, an item is no longer experimental when:</p>

<ul>
 <li>It is implemented in two or more major browsers; or</li>
 <li>Its defining spec is unlikely to change in ways that will break the web.</li>
</ul>

<p>The <em>or</em> is important here — usually if a technology is supported across several major browsers, the spec will be stable, but this is not always the case. And some technologies will have a stable spec and be well-used, but have no native support in browsers (<a href="/en-US/docs/Related/IMSC">IMSC</a>, for example).</p>

<h3 id="Archived_pages">Archived pages</h3>

<p>Archived pages are pages that are stored in the MDN <a href="/en-US/docs/Archive">Archive of obsolete content</a>. These pages contain information out-of-date enough that it is not directly useful to anyone anymore.</p>

<p>Most commonly, these concern Mozilla projects that have been discontinued and shouldn't be relied on anymore. But we don't delete them because they form a useful historical record, and some of the patterns or ideas contained within might be useful for future work. A good example is the <a href="/en-US/docs/Archive/B2G_OS">B2G (Firefox OS) project</a>.</p>

<h4 id="When_should_a_page_be_archived">When should a page be archived?</h4>

<p>A page should be archived if it fits the above description. To archive a page, you should use the "Move page feature" (<em>Advanced &gt; Move this article</em>) to move the page into the Archive page tree (/en-US/docs/Archive). You might not have the permissions to use this feature, and before you start archiving pages you should discuss it with the MDN community first — talk to us on our <a href="https://discourse.mozilla.org/c/mdn">Discourse forum</a>.</p>

<h3 id="Deleted_pages">Deleted pages</h3>

<p>Deleted pages are pages that have been explicitly deleted from MDN — see for example the <code><a href="/en-US/docs/Web/API/SharedKeyframeList">SharedKeyframeList</a></code> interface and <code><a href="/en-US/docs/Web/API/SharedKeyframeList/SharedKeyframeList">SharedKeyframeList()</a></code> constructor. These pages contain information that is not useful in any way anymore, and/or might be incorrect to the point where keeping it available might be confusing or bad for people to know.</p>

<p>These might be:</p>

<ul>
 <li>Reference pages for API features that were removed from the specification before they were implemented in any browsers.</li>
 <li>Articles covering techniques that were later shown to be bad practice and superceded by better techniques.</li>
 <li>Articles containing information that were later replaced by other, better quality articles.</li>
 <li>Articles containing content that is inappropriate for MDN.</li>
 <li>Translations that are old, out-of-date, and difficult to fix, meaning that the English version is preferrable and starting a new translation would be an easier option.</li>
</ul>

<h4 id="When_should_a_page_be_deleted">When should a page be deleted?</h4>

<p>A page should be deleted if it fits the above description. To delete a page, you should use the "Delete this page feature" (<em>Advanced &gt; Delete this page</em>) to delete the page. You will probably not have the permissions to use this feature, and when thinking about deleting pages you should discuss it with the MDN community first — talk to us on our <a href="https://discourse.mozilla.org/c/mdn">Discourse forum</a>.</p>

<h3 id="When_to_document_new_technologies">When to document new technologies</h3>

<p>On MDN, we are constantly looking to document new web standards technologies as appropriate. We try to strike a balance between publishing the documentation early enough so developers can learn about new features as soon as they need to, and publishing it late enough so that the technology is mature and stable so the docs won't need constant updates or rapid removal.</p>

<p>In general, our definition of the earliest we'll consider documenting a new technology is:</p>

<p><em>"When the feature is on a standards track and is implemented somewhere."</em></p>

<p>You should definitely consider documenting a new technology if:</p>

<ul>
 <li>It is specified in a specification document published under a reliable standards organization (such as W3C, WHATWG, Khronos, IETF, etc.), which has reached a reasonable level of stability (e.g. a W3C working draft or candidate recommendation, or the spec is looking to be fairly stable judging by the flow of issues filed against it).</li>
 <li>It is implemented consistently in at least one browser, with other browser developers showing signs of interest (such as an active ticket or "intent to implement" process in effect).</li>
</ul>

<p>You should be more wary of documenting a new technology (but should still consider it if it makes sense) if it:</p>

<ul>
 <li>Doesn't have a spec, or the spec is a rough note that looks liable to change.</li>
 <li>One or zero browsers currently implement it, and non-supporting browsers are not showing signs of interest in implementing it (you can gauge this by asking engineers who work on those browsers, looking at browser bug trackers and mailing lists, etc.).</li>
</ul>

<p>You should not consider documenting a new technology if it:</p>

<ul>
 <li>Is not a web-exposed technology and/or is completely proprietary.</li>
 <li>Is already showing signs of being deprecated, or superseded by a similar feature.</li>
</ul>

<h2 id="Conventions">Conventions</h2>

<h3 id="When_something_is_removed_from_the_specification">When something is removed from the specification</h3>

<p>Sometimes during the development of a new specification, or over the course of the evolution of living standards such as HTML, new elements, methods, properties, and so forth are added to the specification, stay there for a while, then get removed again. Sometimes this happens very quickly, and sometimes these new items remain in the specification for months or even years before being removed. This can make it tricky to decide how to handle the removal of the item from the spec. Here are some guidelines to help you decide what to do.</p>

<div class="note">
<p>For the purposes of this discussion, the word "item" is used to mean anything which can be part of a specification: an element or an attribute of an element, an interface or any individual method, property, or other member of an interface, and so forth.</p>
</div>

<ul>
 <li>If the item was <em>never</em> implemented in a release version of <em>any</em> browser—even behind a preference or flag—delete any references to the item from the documentation.

  <ul>
   <li>If the item has any documentation pages describing only that one item (such as {{domxref("RTCPeerConnection.close()")}}), delete that page. If the removed item is an interface, this means removing any subpages describing the properties and methods on that interface as well.</li>
   <li>Remove the item from any lists of properties, attributes, methods, and so forth. For methods of an interface, that means to remove it from the "Methods" section on the interface's overview page, for example.</li>
   <li>Search the text of the overview page for that interface, element, etc. for any references to the removed item. Remove those references, being sure not to leave weird grammar issues or other problems with the text. This may mean not just deleting words but rewriting a sentence or paragraph to make more sense. It may also mean removing entire sections of content if the description of the item's use is lengthy.</li>
   <li>Similarly, look for any discussion of the item in the guides and tutorials about the relevant API or technology. Remove those references, being sure not to leave weird grammar issues or other problems with the text. This may mean not just deleting words but rewriting a sentence or paragraph to make more sense. It may also mean removing entire sections of content if the description of the item's use is lengthy.</li>
   <li>Search MDN for references to the removed item, in case there are discussions elsewhere. It's unlikely that there are, since if it was never implemented, it's unlikely to be widely discussed. Remove those mentions as well.</li>
   <li>If the <a href="https://github.com/mdn/browser-compat-data">Browser Compatibility Data repository's</a> JSON files contain data for the removed items, delete those objects from the JSON code and submit a PR with that change, explaining why in the commit message and the PR description. Be careful to check that you don't break the JSON syntax while doing this.</li>
  </ul>
 </li>
 <li>If the item was implemented in any release version of any one or more browsers—but <em>only</em> behind a preference or flag—do not delete the item from the documentation immediately. Instead, mark the item as deprecated as follows:
  <ul>
   <li>If the item has any documentation pages describing only that one item (such as {{domxref("RTCPeerConnection.close()")}}), add the {{TemplateLink("deprecated_header")}} macro to the top of the page and add the {{tag("Deprecated")}} tag to the page's list of tags.</li>
   <li>On the overview page for the element, interface, or API, find the list of items which includes the item that's been removed from the specification and add the {{TemplateLink("deprecated_inline")}} macro after the item's name in that list.</li>
   <li>Search the informative text of the overview page for that interface, element, etc. for any references to the removed item. Add warning boxes in appropriate places with text along the lines of "[whatever] has been removed from the specification and will be removed from browsers soon. See [link to page] for a new way to do this."</li>
   <li>Similarly, look for any discussion of the item in the guides and tutorials about the relevant API or technology. Add similar warnings.</li>
   <li>Search MDN for references to the removed item, in case there are discussions elsewhere. Add similar warning boxes there as well.</li>
   <li>At some point in the future, a decision may be made to actually remove the item from the documentation; we don't normally do this but if the item was especially unutilized or uninteresting, we may decide to do so.</li>
   <li>Update any relevant entries in the <a href="https://github.com/mdn/browser-compat-data">Browser Compatibility Data repo</a> to reflect the obsolescence of the item(s) affected.</li>
  </ul>
 </li>
 <li>If the item was implemented in one or more release builds of browsers—without requiring a preference or flag to be changed—mark the item as deprecated, as follows:
  <ul>
   <li>If the item has any documentation pages describing only that one item (such as {{domxref("RTCPeerConnection.close()")}}), add the {{TemplateLink("deprecated_header")}} macro to the top of the page and add the {{tag("Deprecated")}} tag to the page's list of tags.</li>
   <li>On the overview page for the element, interface, or API, find the list of items which includes the item that's been removed from the specification and add the {{TemplateLink("deprecated_inline")}} macro after the item's name in that list.</li>
   <li>Search the informative text of the overview page for that interface, element, etc. for any references to the removed item. Add warning boxes in appropriate places with text along the lines of "[whatever] has been removed from the specification and is deprecated. It may be removed from browsers in the future, so you should not use it. See [link to page] for a new way to do this."</li>
   <li>Similarly, look for any discussion of the item in the guides and tutorials about the relevant API or technology. Add similar warnings.</li>
   <li>Search MDN for references to the removed item, in case there are discussions elsewhere. Add similar warning boxes there as well.</li>
   <li>It's unlikely that these items will be removed from the documentation anytime soon, if ever. It's possible, however, that some or all of the material may be moved to the <a href="/en-US/docs/Archive">Archive</a> section of the site.</li>
   <li>Update any relevant entries in the <a href="https://github.com/mdn/browser-compat-data">Browser Compatibility Data repo</a> to reflect the deprecation of the item(s) affected.</li>
  </ul>
 </li>
</ul>

<p>Please use common sense with wording of warning messages and other changes to text suggested by the guidelines above. Different items will require different wording and handling of the situation. When in doubt, feel free to ask for advice on the <a href="https://chat.mozilla.org/#/room/#mdn:mozilla.org">MDN Web Docs chat room</a> on <a href="https://wiki.mozilla.org/Matrix">Matrix</a>, or on the <a href="https://discourse.mozilla.org/c/mdn">MDN Web Docs discussion forum</a>.</p>

<h3 id="Copying_content_within_MDN">Copying content within MDN</h3>

<p>Sometimes, you need to reuse the same text on multiple pages (or you want to use one page's content as a template for another page). You have three options:</p>

<ul>
 <li>If you want to copy an entire page:
  <ol>
   <li>While viewing the page you want to copy, on the <strong>Advanced</strong> (gear) menu, choose  <strong><a href="/en-US/docs/MDN/Contribute/Creating_and_editing_pages#Clone_of_an_existing_page">Clone this page</a></strong>. This opens the editor UI for a new page, with the contents of the cloned page already populated.</li>
   <li>Enter a new <strong>Title</strong> and <strong>Slug</strong> for the cloned page.</li>
   <li>Edit the contents of the page as needed, and save as usual.</li>
  </ol>
 </li>
 <li>If you want to copy just part of a page, <strong>don't just visit the page and copy from it</strong>. This introduce unwanted additional bits of HTML into the destination page, and somebody will have to clean that up, you or another editor. Nobody wants that. To copy part of an MDN page to another page:
  <ol>
   <li>On the source page, click the <strong>Edit</strong> button on the source page.</li>
   <li><strong>Copy the content you want to reuse from within the editor UI.</strong></li>
   <li>Click <strong>Discard</strong> to exit the editor UI for that page.</li>
   <li>Open the editor UI for page where you want to paste.</li>
   <li>Paste the content from the clipboard.</li>
  </ol>

  <div class="note"><strong>Chrome users:</strong> Chrome does not generally include the classes applied to content when copying and pasting across documents in our editor. You need to review the content after doing this and re-apply the lost styles. Check tables, syntax boxes, syntax highlighting, and hidden sections of content in particular.</div>
 </li>
 <li>Sometimes you literally want to use the same content on many pages. In this case, you might be best off placing the content in one page, then using the {{TemplateLink("Page")}} macro to transclude the material from one page into another. This way, whenever the text on the source page is updated, the destination page will update as well (that is, this will happen on a forced-refresh or when the target page goes through a scheduled rebuild).</li>
</ul>

<h4 id="Copying_content_from_elsewhere">Copying content from elsewhere</h4>

<p>Often, there is useful content about a topic somewhere on the web besides on MDN. However, copying such content can be fraught with difficulties, both legal and technical.</p>

<p>On the technical level, search engines typically penalize a site in their rankings for reproducing content available elsewhere. Therefore, it is preferable to have original content on MDN, to enhance the search engine ranking of MDN's content. You can link to the existing content from MDN.</p>

<p>On the legal level, you must be authorized to contribute the content, and it must be licensed and attributed in a way that is compatible with <a href="/en-US/docs/MDN/About#Copyrights_and_licenses">MDN's license</a>.</p>

<ul>
 <li><strong>If you created the existing content</strong> (for your own purposes and not as work-for-hire), and you are willing to contribute it to MDN under MDN's license, this is the easiest case, and you are free to contribute the content.</li>
 <li><strong>If the copyright for the content belongs to someone else</strong>, it must be licensed and attributed compatibly with MDN's license. It is often not easy for someone who is not a lawyer to determine what licenses are compatible. To be on the safe side, contact a member of the <a href="https://wiki.mozilla.org/MDN#Staff_Team">MDN staff team</a>, who may consult Mozilla's Legal team for guidance if necessary.</li>
</ul>

<h4 id="How_to_communicate_a_spec_conflict">How to communicate a spec conflict</h4>

<p>Note that sometimes (but rarely) there is a conflict between different spec versions (usually W3C versus WHATWG), e.g. one version might have a feature listed as deprecated, while the other doesn't. In such cases, consider what the reality is — i.e. what browsers are actually doing — and write an "important" note to summarize that latest status. For example, as of Jan 2019 the <code><a href="/en-US/docs/Web/HTML/Global_attributes/inputmode">inputmode</a></code> global attribute has a conflict, which was summarized like so:</p>

<div class="notecard warning">
<p><strong>Spec conflict</strong>: The <a href="https://html.spec.whatwg.org/multipage/interaction.html#attr-inputmode">WHATWG spec lists <code>inputmode</code></a>, and modern browsers are working towards supporting it. The <a href="https://www.w3.org/TR/html52/index.html#contents">W3C HTML 5.2 spec</a> however no longer lists it (i.e. marks it as obsolete). You should consider the WHATWG definition as correct, until a consensus is reached.=</p>
</div>
